﻿# Nightwave.NET for Workgroups

An unofficial client for [Nightwave Plaza][1], which aims to
implement as much functionality of the site as possible
while maintaining aesthetics.

You can [get it here][6].

Intended future improvements include:
* Multiple visualiser types
* Better use of additional application real-estate when resized
* Integration with the Windows native media APIs (so keyboard play/pause buttons work)
* Storage for window height/width, always-on-top and volume state
* Log-out button lmfao
* Miniplayer!

## First-Party

Nightwave.NET uses **libplaza**, a basic .Net interface for
the Nightwave Plaza API. **libplaza** can be found in the same
Git repository as **Nightwave.NET for Workgroups**.

## Third-Party

Nightwave.NET uses the following third-party libraries and resources:
* [BASS][2] by Un4Seen Developments, via .Net wrapper library [ManagedBass][3] by Mathew Sachin, for audio streaming and playback functionality.
* [JSON.Net][4] by Newtonsoft for deserialisation of JSON strings.
* [CredentialManager][5] by Meziantou for access to the Windows Credential Manager APIs

## Privacy, data collection & usage

Nightwave.NET collects the following information and stores it locally in your Windows install's Enterprise Credentials Store:
* Username for Nightwave Plaza
* Password for Nightwave Plaza (encrypted)

Nightwave.NET does not transmit any data over the internet itself, however the Nightwave Plaza library interface, **libplaza**, uploads the following information to remote servers:
* Username and Password for Nightwave Plaza, uploaded by means of the Nightwave Plaza standard login mechanism, to **api.plaza.one/user/auth**, the standard login endpoint for Nightwave Plaza
* Your vote for the current track, whenever you cast it, uploaded by means of the Nightwave Plaza reactions mechanism, to **api.plaza.one/reactions**, the standard voting endpoint for Nightwave Plaza

Nightwave.NET and libplaza are both developed solely by me, and do not collect any information not mentioned here. To the best of my knowledge and personal verification,
no third-party library in use by either Nightwave.NET or libplaza collects any data or makes any network connections, with the exception of **BASS**, which
makes one network connection: to stream the Nightwave Radio audio stream to your computer.

[1]: https://plaza.one
[2]: https://www.un4seen.com/bass.html
[3]: https://github.com/ManagedBass/ManagedBass
[4]: https://github.com/JamesNK/Newtonsoft.Json
[5]: https://github.com/meziantou/Meziantou.Framework
[6]: https://soft.pup.cloud/Nightwave.NET/